package org.example.models;


import lombok.*;
import lombok.experimental.FieldDefaults;
import org.neo4j.ogm.annotation.EndNode;
import org.neo4j.ogm.annotation.RelationshipEntity;
import org.neo4j.ogm.annotation.StartNode;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@FieldDefaults(level = AccessLevel.PRIVATE)
@RelationshipEntity(type = "LIKE")
public class Like {
    Long userId;
    Long postId;
    String status;

    @StartNode
    private User user;

    @EndNode
    private Post post;
}
